/*=======================================================*/
/*  TVINT15N.C                                           */
/*     low-level functions for TV software interrupts    */
/*     requires MASM or A86 to recompile                 */
/*                                                       */
/*  (c) Copyright 1988 Ralf Brown  All Rights Reserved   */
/*  May be freely copied for noncommercial use, so long  */
/*  as this copyright notice remains intact, and any     */
/*  changes are marked in the comment blocks preceding   */
/*  functions.                                           */
/*=======================================================*/

#pragma inline

#include "tvapi.h"

/*======================================================*/
/* _TVnotify_handler  low-level function which passes   */
/*                   control to user notification       */
/*                   handler                            */
/*   Ralf Brown 4/4/88                                  */
/*======================================================*/

void far pascal _TVnotify_handler(void)
{
   asm push bx
   asm push cx
   asm mov bx,ss
   asm mov cx,sp
   asm cli
   asm mov ax,ds
   asm mov ss,ax         /* SS = segment of local stack data structure */
   asm mov sp,ss:[si+4]  /* get stacktop out of our data structure */
   asm sti
   asm push bx
   asm push cx
   asm push ds
/* now that we've saved all the necessary registers, call the real handler */
   asm mov ax,DGROUP      /* initialize DS to our own data segment */
   asm mov ds,ax
   asm call dword ptr ss:[si]
/* restore the registers and return */
   asm pop ds
   asm pop cx
   asm pop bx
   asm cli
   asm mov ss,bx
   asm mov sp,cx
   asm sti
   asm pop cx
   asm pop bx
}

/* End of TVINT15N.C */
